<!DOCTYPE html>
<html lang="en">
  <head>
    {{> ../head}}
  </head>
  <body>
    <header class="header">
      <a class="root" href="{{{ROOT_PATH}}}">Timetable Site</a>
      <div class="title" style="display: none;"></div>
      <div class="space"></div>
      <div class="other">
        <a class="source button" target="_blank" href="https://gitlab.com/hqurve-site/timetable">Source Tree</a>
      </div>
    </header>
    <section class="links" id="links">
      <a href="{{{ROOT_PATH}}}/builder">
        <div class="title">Builder</div>
        <div class="description">Combine many timetables into one</div>
      </a>
      <a href="{{{ROOT_PATH}}}/listing">
        <div class="title">Container Listing</div>
        <div class="description">Search and view all containers</div>
      </a>
      <a href="{{{ROOT_PATH}}}/viewer">
        <div class="title">Timetable Viewer</div>
        <div class="description">Load saved timetable from file or manually written query</div>
      </a>
    </section>
    <section class="more">
      <section class="caution">
        <div class="title">Caution</div>
        <div>
          Although this project automatically collects information posted by UWI, it should not
          be used as a primary source as no software is perfect. Rather, compare both
          sets of information prior to utilizing. If there is any discreprency, please
          let me know either via a
          <a href="https://gitlab.com/hqurve-site/timetable/data-control/-/issues">bug report</a>
          or email to <a href="mailto:hqurve@outlook.com">hqurve@outlook.com</a>.
        </div>
      </section>
      <section class="about">
        <div class="title">About</div>
        <div>
          The method in which UWI publishes timetable information is the primary contributing factor
          for the existence of this project. On
          <a href="https://mysta.uwi.edu/timetable">https://mysta.uwi.edu/timetable</a>,
          UWI publishes PDFs for each of its
          courses and rooms, each of which contain a timetable with several sessions.
          Despite the simplicity of this method, it provides no method for the user (student)
          to aggregate the multiple timetables for simple presentation. This results in students having
          to manually recreate the data for their registered courses which is time-consuming and error prone.
          This project seeks to alleviate both of these issues by mirroring information posted on
          aforementioned website for both current and previous semesters,
          and providing a simple method for aggregating timetable data.
        </div>

        <!-- <div> -->
        <!--   To achieve this, the posted information is periodically fetched and parsed  -->
        <!-- </div> -->

          <!-- However, in theory, it can be configured -->
          <!-- to suite any other timetable needs, as long as the architecture does not deviate significantly. -->
          <!---->
          <!-- Its purpose is two fold; primarily, it acts as a public archive for UWI's Timetable Data -->
          <!-- and secondarily, it provides a simple way to combine  -->
          <!-- The purpose of this project is two fold. Primarily, it provides a way to combine mul -->
      </section>
      <section class="components">
        <div class="title">Components</div>
        <div>
          This project comprises of four main components

          <div class="list">
            <div>
              <div>
                Data Control
                <a href="https://gitlab.com/hqurve-site/timetable/data-control">[repo]</a>
              </div>
              <div>
                This component coordinates all operations and stores configuration and human verified data.
                This is necessary as the configuration for both the <code>extractor</code> and <code>site</code>
                can be tedious to write and is better automated.
              </div>
              <div>
                This component also periodically downloads the information (including PDF's) posted on
                <a href="https://mysta.uwi.edu/timetable/">https://mysta.uwi.edu/timetable</a>,
                and stores the changes in the <code>data-history</code> repo.
                Automatic parsing was previously performed, but I no longer want to do this since it required
                usage of pull requests and relied on my intervention (in any case).
                Now, parsing is only done when I get the chance, and the automatic downloading ensures that I
                capture everything.
              </div>
            </div>
            <div>
              <div>
                Data History
                <a href="https://gitlab.com/hqurve-site/timetable/data-history">[repo]</a>
              </div>
              <div>
                As its name implies, this is where most data is stored. Each time the automatic download
                of <a href="https://mysta.uwi.edu/timetable/">https://mysta.uwi.edu/timetable</a>
                is triggered, the result is stored in this repository.
              </div>
            </div>
            <div>
              <div>Extractor
                <a href="https://gitlab.com/hqurve-site/timetable/extractor">[repo]</a>
              </div>
              <div>
                This tool, parses and aggregates all previously downloaded timetable information
                posted on <a href="https://mysta.uwi.edu/timetable/">https://mysta.uwi.edu/timetable</a>.
                It exports a set of <code>containers</code> and <code>sessions</code> in a many-to-many relationship.
              </div>
              <div>
                Firstly, we parse each of the downloaded PDF files.
                Since the PDF specification
                only provides a way to visually reproduce the document, parsing is a bit more difficult
                than may be expected. We first extract all text and line information to produce a set of regions
                matching an expected template, then we analyze the text in each region to generate the timetable data.
                Finally, we aggregate and deduplicate information in each PDF to produce a single file.
              </div>
              <div>
                Analyzing the text from the PDFs is handled by regular expressions since data must also be sanitized due to
                line breaks and inconsistencies in formatting. For example, the only consistent way to match
                a course or room code is to know if before hand and even then, some published PDFs
                contain <code>GEND 5002/6003/7002/8002</code> to represent 4 courses while almost everywhere
                else would write them separately. Additionally, many published sessions contain additional
                information such as notices, groupings and members of staff which do not all follow the same standard.
                For example, each of the following were used indicate that a session is only for civil engineering students:

                <ul>
                  <li>Civ Eng</li>
                  <li>Civil Eng</li>
                  <li>Civil Group</li>
                  <li>Civ Eng Group</li>
                  <li>Civil Eng Group</li>
                </ul>

                each with varying capitalization.
                Furthermore, sometimes different ones were even used in the same PDF!
                <a href="https://mysta.uwi.edu/timetable/m2505.pdf">[source]</a>
                <a href="https://gitlab.com/hqurve-site/timetable/data-dump/-/blob/b73817ed10da2382866fcd7edb5444b6eb0b453a/data/pdf(download)/2505.pdf">[archive]</a>
                <a href="https://web.archive.org/web/20220806002858/https://mysta.uwi.edu/timetable/m2505.pdf">[wayback]</a>.
                Regular expressions are very flexible and allow for simple(r) parsing.
              </div>
            </div>
            <div>
              <div>
                Site
                <a href="https://gitlab.com/hqurve-site/timetable/site">[repo]</a>
              </div>
              <div>
                This is the main interface for the user. It contains this page as well as several others
                which allow the user to aggregate and view timetables. Currently, all timetable
                data is processed on the client; however, the code base is written in such a way
                that this processing can be done by a server.
              </div>
              <div>
                Currently the only way (aside from writing manual requests) for aggregating timetables is using the builder.
                The user firstly chooses a container (session/room) from which they can visually select sessions.
                From this a query is generated which negates all unselected sessions from the
                requested container. By doing this, the user will be notified of any additional
                sessions which may be added.
              </div>
            </div>
          </div>
        </div>
      </section>
      <section class="">
      </section>
    </section>
  </body>
</html>
